/*
 * File: CountLetterFrequencies.js
 * -------------------------------
 * This function displays a letter-frequency table for a file.
 */

/* Lets the user choose a file and displays the frequency table */

function CountLetterFrequencies() {
   let callback = function(text) {
      displayFrequencyTable(createFrequencyTable(text));
   };
   JSFileChooser.chooseTextFile(callback)
}

/* Creates and returns an array with n copies of value */

function createArray(n, value) {
   let array = [];
   for (let i = 0; i < n; i++) array.push(value);
   return array;
}

/*
 * Creates a letter frequency table from the specified string.
 */

function createFrequencyTable(str) {
   let letterCounts = createArray(26, 0);
   for (let i = 0; i < str.length; i++) {
      let ch = str.charAt(i).toUpperCase();
      if (ch >= "A" && ch <= "Z") {
         letterCounts[ch.charCodeAt(0) - "A".charCodeAt(0)]++;
      }
   }
   return letterCounts;
}

/*
 * Displays the frequency table.  Letters that never appear are not shown.
 */

function displayFrequencyTable(letterCounts) {
   for (let i = 0; i < 26; i++) {
      let count = letterCounts[i];
      if (count > 0) {
         let ch = String.fromCharCode("A".charCodeAt(0) + i);
         console.log(ch + ": " + count);
      }
   }
}
